<?php

namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc01000VendasConciliadasFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getLoteVenda($params) {
        $sql = "SELECT DISTINCT CABECALHO.*,
       COUNT(R.NRRETVENDAADQ) OVER (PARTITION BY R.NRESTABELEC, R.NRLOTEVENDA, R.NRPRODUTOADQ) QTVENDPEND
  FROM (SELECT P.DTLOTE, P.DTCREDITO, P.NRLOTEVENDA, P.CDLOTEVENDA, P.NRESTABELEC, P.CDESTABELEC, P.NMESTABELEC, P.NRADQUIRENTE, P.NMADQUIRENTE,
                P.NMPRODUTOADQ, P.NRPRODUTOADQ, P.AZUL, P.VERDE, P.PRETO, 
                SUM(P.VRBRUTVENDA) VRBRUTVENDA,
                SUM(P.VRCOBRADOTAXA) VRCOBRADOTAXA, SUM(P.VRTAXAPREV) VRTAXAPREV, 
                NVL(SUM(P.VRLIQPGTO), 0) VRLIQPGTO, SUM(P.VRLIQVENDA) VRLIQVENDA, 
                SUM(P.VRTAXAADMRV) VRTAXAADMPREV, SUM(P.VRTAXAADMRF) VRTAXAADMPGTO,
                COUNT(*) TVDLOTE
          FROM (SELECT DTLOTE, TO_CHAR(L.DTLOTE, 'DD/MM/YYYY') DTCREDITO, L.NRLOTEVENDA, L.CDLOTEVENDA,
                       E.NRESTABELEC, E.CDESTABELEC, E.NMESTABELEC, A.NRADQUIRENTE, A.NMADQUIRENTE, P.NMPRODUTOADQ, RV.NRPRODUTOADQ, RV.VRBRUTVENDA, 
                       RV.VRLIQVENDA, RF.VRCOBRADOTAXA, 
                       RF.VRLIQPGTO, RV.VRTAXAPREV,
                       RV.VRTAXAADM VRTAXAADMRV, RF.VRTAXAADM VRTAXAADMRF,
                       DECODE(SUM(DECODE(RV.IDSITUACAO, 'O', 1, 0)) OVER (PARTITION BY RV.NRESTABELEC, RV.NRPRODUTOADQ, RV.NRLOTEVENDA), 0, 'N', 'S') AZUL,
                       DECODE(SUM(DECODE(RV.IDSITUACAO, 'C', 1, 0)) OVER (PARTITION BY RV.NRESTABELEC, RV.NRPRODUTOADQ, RV.NRLOTEVENDA), 0, 'N', 'S') VERDE,
                       DECODE(SUM(DECODE(RV.IDSITUACAO, 'N', 1, 0)) OVER (PARTITION BY RV.NRESTABELEC, RV.NRPRODUTOADQ, RV.NRLOTEVENDA), 0, 'N', 'S') PRETO
                  FROM LOTEVENDA L, ESTABELECIMENTO E, PRODUTOADQ P,
                       RETVENDAADQ RV LEFT JOIN RETFINANCADQ RF
                                             ON RV.CDNSU = RF.CDNSU
                                            AND RV.DTVENDA = RF.DTVENDA
                                            AND RV.NRADQUIRENTE = RF.NRADQUIRENTE
                                            AND RV.NRCONCLANCPGTO = RF.NRCONCLANC
                                            AND RV.NRPRODUTOADQ = RF.NRPRODUTOADQ
                                            AND RV.NRPARCELA = RF.NRPARCELA, ADQUIRENTE A
                    WHERE L.NRADQUIRENTE = RV.NRADQUIRENTE
                      AND L.NRLOTEVENDA = RV.NRLOTEVENDA
                      AND E.NRESTABELEC = RV.NRESTABELEC
                      AND A.NRADQUIRENTE = RV.NRADQUIRENTE
                      AND P.NRPRODUTOADQ = RV.NRPRODUTOADQ
                      AND ((INSTR (:NRESTABELEC, '|'||TO_CHAR(E.NRESTABELEC)||'|') > 0) OR ('T' = :TNRESTABELEC))
                      AND ((INSTR (:NRADQUIRENTE, '|'||TO_CHAR(A.NRADQUIRENTE)||'|') > 0) OR ('T' = :TNRADQUIRENTE))
                      AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(RV.NRPRODUTOADQ)||'|') > 0) OR ('T' = :TNRPRODUTOADQ))
                      AND ((INSTR (:IDCONCILIADO, RV.IDCONCILIADO) > 0) OR ('T' = :TIDCONCILIADO))
                      AND ((INSTR (:IDFINRECEBIDO, RV.IDFINRECEBIDO) > 0) OR ('T' = :TIDFINRECEBIDO))
                      AND ((INSTR (:IDSITUACAO, RV.IDSITUACAO) > 0) OR ('T' = :TIDSITUACAO))
                      AND L.DTLOTE BETWEEN :DTLOTEINI AND :DTLOTEFIN
                      AND L.CDLOTEVENDA LIKE '%'||:CDLOTEVENDA||'%'
                      AND NVL(RV.CDNSU, '%') LIKE '%'||:CDNSU||'%'
                      AND :NRORG = RV.NRORG
                      AND RV.NRORG = A.NRORG
                      AND L.IDTIPOLOTE <> 'A') P
        GROUP BY P.DTLOTE, P.DTCREDITO, P.NRLOTEVENDA, P.CDLOTEVENDA, P.NRADQUIRENTE, P.NMADQUIRENTE,
                P.NMPRODUTOADQ, P.NRPRODUTOADQ, P.AZUL, P.VERDE, P.PRETO, P.NRESTABELEC, P.CDESTABELEC, P.NMESTABELEC) CABECALHO LEFT JOIN RETVENDAADQ R
                                                                                                                         ON R.NRLOTEVENDA = CABECALHO.NRLOTEVENDA
                                                                                                                        AND R.NRPRODUTOADQ = CABECALHO.NRPRODUTOADQ
                                                                                                                        AND R.NRESTABELEC = CABECALHO.NRESTABELEC
                                                                                                                        AND R.NRADQUIRENTE = CABECALHO.NRADQUIRENTE
                                                                                                                        AND R.IDCONCILIADO = 'P'

ORDER BY CABECALHO.DTLOTE, CABECALHO.NRESTABELEC, CABECALHO.NMESTABELEC, CABECALHO.NRADQUIRENTE, CABECALHO.NMPRODUTOADQ, CABECALHO.CDLOTEVENDA";
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }      

    public function getDivergenceConciliator($params) {
        $sql = "SELECT R.NRCONCLANC, R.NRRETVENDAADQ, DSTIPODIV, VRESPERADO, VRENCONTRADO 
                  FROM RETVENDAADQ R, CONCILIACAOLANC C, DIVCONCILIACAO D, TIPODIVERGENCIA TP
                 WHERE R.NRRETVENDAADQ = :NRRETVENDAADQ
                   AND R.NRCONCLANC = C.NRCONCLANC
                   AND C.NRCONCLANC = D.NRCONCLANC   
                   AND D.NRTPDIVERGENCIA = TP.NRTPDIVERGENCIA
                  AND TP.IDDIVERGENCIA NOT IN ('P')
                UNION
                SELECT R.NRCONCLANC, R.NRRETVENDAADQ, TP.DSTIPODIV, P.NMPRODUTOADQ VRESPERADO, PR.NMPRODUTOADQ VRENCONTRADO 
                                  FROM RETVENDAADQ R, DIVCONCILIACAO D
                                    JOIN PRODUTOADQ P
                                     ON  D.VRESPERADO = P.NRPRODUTOADQ
                                      JOIN PRODUTOADQ PR
                                       ON  D.VRENCONTRADO = PR.NRPRODUTOADQ
                                        JOIN TIPODIVERGENCIA TP
                                         ON  D.NRTPDIVERGENCIA = TP.NRTPDIVERGENCIA
                                          AND TP.IDDIVERGENCIA = 'P'
                                           JOIN CONCILIACAOLANC C
                                            ON  D.NRCONCLANC = C.NRCONCLANC
                                   WHERE R.NRRETVENDAADQ = :NRRETVENDAADQ
                                    AND R.NRCONCLANC = C.NRCONCLANC";                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getPaymentConciliator($params) {
        $sql = "SELECT R.NRCONCLANC, R.NRRETVENDAADQ, DSTIPODIV, VRESPERADO, VRENCONTRADO
                  FROM RETVENDAADQ R, CONCILIACAOLANC C, DIVCONCILIACAO D, TIPODIVERGENCIA TP
                 WHERE R.NRRETVENDAADQ = :NRRETVENDAADQ
                   AND R.NRCONCLANCPGTO = C.NRCONCLANC
                   AND C.NRCONCLANC = D.NRCONCLANC 
                   AND D.NRTPDIVERGENCIA = TP.NRTPDIVERGENCIA
                   AND TP.IDDIVERGENCIA NOT IN ('A','P')
                UNION
                SELECT R.NRCONCLANC, R.NRRETVENDAADQ, TP.DSTIPODIV, P.NMPRODUTOADQ VRESPERADO, PR.NMPRODUTOADQ VRENCONTRADO 
                                  FROM RETVENDAADQ R, DIVCONCILIACAO D
                                    JOIN PRODUTOADQ P
                                     ON  D.VRESPERADO = P.NRPRODUTOADQ
                                      JOIN PRODUTOADQ PR
                                       ON  D.VRENCONTRADO = PR.NRPRODUTOADQ
                                        JOIN TIPODIVERGENCIA TP
                                         ON  D.NRTPDIVERGENCIA = TP.NRTPDIVERGENCIA
                                          AND TP.IDDIVERGENCIA = 'P'
                                           JOIN CONCILIACAOLANC C
                                            ON  D.NRCONCLANC = C.NRCONCLANC
                                   WHERE R.NRRETVENDAADQ = :NRRETVENDAADQ
                                    AND R.NRCONCLANCPGTO = C.NRCONCLANC
                UNION
                SELECT R.NRCONCLANC, R.NRRETVENDAADQ, TP.DSTIPODIV, A.NMADQUIRENTE VRESPERADO, AD.NMADQUIRENTE VRENCONTRADO 
                                  FROM RETVENDAADQ R, DIVCONCILIACAO D
                                    JOIN ADQUIRENTE A
                                     ON  D.VRESPERADO = A.NRADQUIRENTE
                                      JOIN ADQUIRENTE AD
                                       ON  D.VRENCONTRADO = AD.NRADQUIRENTE
                                        JOIN TIPODIVERGENCIA TP
                                         ON  D.NRTPDIVERGENCIA = TP.NRTPDIVERGENCIA
                                          AND TP.IDDIVERGENCIA = 'A'
                                           JOIN CONCILIACAOLANC C
                                            ON  D.NRCONCLANC = C.NRCONCLANC
                                   WHERE R.NRRETVENDAADQ = :NRRETVENDAADQ
                                    AND R.NRCONCLANCPGTO = C.NRCONCLANC";                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getAdjustmentConciliator($params) {
        $sql = "SELECT R.NRCONCLANC, R.NRRETVENDAADQ, CO.IDSITUACAO, IO.DSITEMCORRECAO, IA.VRANTIGO, IA.VRNOVO
                  FROM RETVENDAADQ R, ITEMCORRECAO IO, CONSMOVCAIXA CO, CONCILIACAOLANC C, ITEMCORVENDA IA
                   WHERE CO.NRCONCLANC = C.NRCONCLANC
                     AND R.NRCONCLANC = CO.NRCONCLANC
                     AND R.NRCONCLANC = C.NRCONCLANC
                     AND CO.NRCONSMOVCAIXA = IA.NRCONSMOVCAIXA
                     AND R.NRRETVENDAADQ = :NRRETVENDAADQ
                     AND IO.NRITEMCORRECAO = IA.NRITEMCORRECAO
                  ORDER BY IO.DSITEMCORRECAO";                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getParcelasVenda($params) {
      $sql = "SELECT *
      FROM (SELECT PRIMARY, PARENT, DTVENDA, '' DTCREDITOPREV, '' DTCREDITO, NULL NRRETVENDAADQ, NRLOTEVENDA, 
                   CDNSU, NRPARCELA, NRADQUIRENTE, NMPRODUTOADQ, SUM(VRBRUTVENDA) VRBRUTVENDA, 
                   SUM(VRLIQVENDA) VRLIQVENDA, SUM(VRCOBRADOTAXA) VRCOBRADOTAXA, SUM(VRLIQPGTO) VRLIQPGTO, 
                   SUM(VRTAXAPREV) VRTAXAPREV, SUM(QTPREV) QTPREVISTO, SUM(QTPAGO) QTPAGOS, 
                   '' IDSTATUSVENDA, '' DSAJUSTE, '' NRTERMINAL, '' VRTAXAADMPREV, '' VRTAXAADMPGTO, '' VRTAXAANTVENDA,
                   SUM(AZUL) AZUL, SUM(VERDE) VERDE, SUM(PRETO) PRETO, '' STATUSSIT, '' STATUSCON, '' NRAUTORIZACAO
              FROM (SELECT RV.NRLOTEVENDA || '-' || RV.NRPRODUTOADQ PRIMARY, '' PARENT,
                           '' DTVENDA, RV.NRRETVENDAADQ, L.NRLOTEVENDA NRLOTEVENDA,
                           '' CDNSU, NULL NRPARCELA, RV.NRADQUIRENTE, P.NMPRODUTOADQ, RV.VRBRUTVENDA, RV.VRLIQVENDA,
                           RF.VRCOBRADOTAXA, RF.VRLIQPGTO, RV.VRTAXAPREV,
                           DECODE(RV.NRRETVENDAADQ, NULL, 0, 1) QTPREV,
                           DECODE(RF.NRRETFINANCADQ, NULL, 0, 1) QTPAGO,
                           RF.IDSTATUSVENDA, '' DSAJUSTE, RV.NRTERMINAL,
                           DECODE(RV.IDSITUACAO, 'O', 1, 0) AZUL,
                           DECODE(RV.IDSITUACAO, 'C', 1, 0) VERDE,
                           DECODE(RV.IDSITUACAO, 'N', 1, 0) PRETO
                      FROM RETVENDAADQ RV LEFT JOIN RETFINANCADQ RF
                                                 ON RV.CDNSU = RF.CDNSU
                                                AND RV.DTVENDA = RF.DTVENDA
                                                AND RV.NRPARCELA = RF.NRPARCELA
                                                AND RV.NRCONCLANCPGTO = RF.NRCONCLANC
                                                AND RV.NRADQUIRENTE = RF.NRADQUIRENTE
                                                AND IDSTATUSVENDA IN ('L', 'C', 'A'),
                        ESTABELECIMENTO E, LOTEVENDA L, ADQUIRENTE A, PRODUTOADQ P
                      WHERE RV.NRLOTEVENDA = L.NRLOTEVENDA
                        AND RV.NRADQUIRENTE = A.NRADQUIRENTE
                        AND RV.NRESTABELEC = E.NRESTABELEC
                        AND E.NRESTABELEC = :NRESTABELEC
                        AND L.NRLOTEVENDA = :NRLOTEVENDA
                        AND RV.CDNSU LIKE '%'||:CDNSU||'%'
                        AND INSTR ('|'||TO_CHAR(A.NRADQUIRENTE)||'|', :NRADQUIRENTE) <> 0
                        AND INSTR ('|'||TO_CHAR(P.NRPRODUTOADQ)||'|', :NRPRODUTOADQ) <> 0 
                        AND ((INSTR (RV.IDCONCILIADO, :IDCONCILIADO) <> 0) OR ('T' = :TIDCONCILIADO))
                        AND ((INSTR (RV.IDSITUACAO, :IDSITUACAO) <> 0) OR ('T' = :TIDSITUACAO))
                        AND ((INSTR (RV.IDFINRECEBIDO, :IDFINRECEBIDO) > 0) OR ('T' = :TIDFINRECEBIDO))
                        AND RV.NRPRODUTOADQ = P.NRPRODUTOADQ)
             GROUP BY PRIMARY, DTVENDA, NRLOTEVENDA, NRPARCELA, NRADQUIRENTE, NMPRODUTOADQ
             UNION
            SELECT RV.NRPRODUTOADQ || '-' || RV.NRPARCELA PRIMARY, RV.NRLOTEVENDA || '-' || RV.NRPRODUTOADQ PARENT,
                  TO_CHAR(RV.DTVENDA, 'DD/MM/YYYY') DTVENDA, TO_CHAR(RV.DTCREDITO, 'DD/MM/YYYY') DTCREDITOPREV,
                  TO_CHAR(RF.DTCREDITO, 'DD/MM/YYYY') DTCREDITO, RV.NRRETVENDAADQ, L.NRLOTEVENDA,
                  RV.CDNSU, RV.NRPARCELA, RV.NRADQUIRENTE, P.NMPRODUTOADQ, RV.VRBRUTVENDA, RV.VRLIQVENDA,
                  RF.VRCOBRADOTAXA, RF.VRLIQPGTO, RV.VRTAXAPREV,
                  DECODE(RV.NRRETVENDAADQ, NULL, 0, 1) QTPREV,
                  DECODE(RF.NRRETFINANCADQ, NULL, 0, 1) QTPAGO,
                  RF.IDSTATUSVENDA, RF.DSAJUSTE, RV.NRTERMINAL, TO_CHAR(RV.VRTAXAADM) VRTAXAADMPREV, TO_CHAR(RF.VRTAXAADM) VRTAXAADMPGTO,
                  TO_CHAR(RF.VRTAXAANTVENDA),
                  DECODE(RV.IDSITUACAO, 'O', 1, 0) AZUL,
                  DECODE(RV.IDSITUACAO, 'C', 1, 0) VERDE,
                  DECODE(RV.IDSITUACAO, 'N', 1, 0) PRETO, RV.IDSITUACAO STATUSSIT, RV.IDCONCILIADO STATUSCON, RV.NRAUTORIZACAO
             FROM RETVENDAADQ RV LEFT JOIN RETFINANCADQ RF
                                        ON RV.CDNSU = RF.CDNSU
                                       AND RV.DTVENDA = RF.DTVENDA
                                       AND RV.NRPARCELA = RF.NRPARCELA
                                       AND RV.NRCONCLANCPGTO = RF.NRCONCLANC
                                       AND RV.NRADQUIRENTE = RF.NRADQUIRENTE
                                       AND IDSTATUSVENDA IN ('L', 'C', 'A'),
                  ESTABELECIMENTO E, LOTEVENDA L, ADQUIRENTE A, PRODUTOADQ P
             WHERE RV.NRLOTEVENDA = L.NRLOTEVENDA
               AND RV.NRADQUIRENTE = A.NRADQUIRENTE
               AND RV.NRESTABELEC = E.NRESTABELEC
               AND E.NRESTABELEC = :NRESTABELEC
               AND L.NRLOTEVENDA = :NRLOTEVENDA
               AND RV.CDNSU LIKE '%'||:CDNSU||'%'
               AND INSTR ('|'||TO_CHAR(A.NRADQUIRENTE)||'|', :NRADQUIRENTE) <> 0
               AND INSTR ('|'||TO_CHAR(P.NRPRODUTOADQ)||'|', :NRPRODUTOADQ) <> 0
               AND ((INSTR (RV.IDCONCILIADO, :IDCONCILIADO) <> 0) OR ('T' = :TIDCONCILIADO))
               AND ((INSTR (RV.IDSITUACAO, :IDSITUACAO) > 0) OR ('T' = :TIDSITUACAO))
               AND ((INSTR (RV.IDFINRECEBIDO, :IDFINRECEBIDO) > 0) OR ('T' = :TIDFINRECEBIDO))
               AND RV.NRPRODUTOADQ = P.NRPRODUTOADQ)
     ORDER BY DTVENDA, DTCREDITOPREV, VRBRUTVENDA, PRIMARY";
      
      $std = $this->connection->prepare($sql);
      $std->execute($params);
      return $std->fetchAll();
    }
    
}