<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc02000RelVendaInexisAdqFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getnotExistAcquireSells ($params) {
        $sql = "SELECT TO_CHAR(CO.DTVENDA, 'DD/MM/YYYY') DTVENDA, CO.CDFILIAL, F.NMFILIAL, CO.CDTIPORECE, TP.NMTIPORECE, CO.CDNSU, 
                 CO.CDCUPOM, CO.VRVENDATOT, CO.VRVENDA, :DTVENDAINI ||' a '|| :DTVENDAFIN PERIODO
                 FROM CONSMOVCAIXA CO
                  JOIN FILIAL F
                   ON CO.CDFILIAL = F.CDFILIAL
                  JOIN TIPORECE TP
                   ON CO.CDTIPORECE = TP.CDTIPORECE
                  WHERE NOT EXISTS(
                    SELECT 1 FROM RETVENDAADQ RE
                     WHERE CO.NRCONCLANC = RE.NRCONCLANC
                  )
                  AND DTVENDA BETWEEN TO_DATE(:DTVENDAINI, 'dd/mm/yy') AND TO_DATE(:DTVENDAFIN, 'dd/mm/yy')
                  AND ((VRVENDA BETWEEN :VRVENDAINI AND :VRVENDAFIN)OR ('T' = :P_TVRVENDA))
                  AND CO.CDFILIAL = :CDFILIAL
                  AND CO.NRORG = :NRORG
                ORDER BY CO.DTVENDA, CO.VRVENDA, CO.CDNSU";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}